makedefs revision 1.14 1 1.1 tron #!/bin/sh
2 1.1 tron
3 1.13 christos # To view the formatted manual page of this file, type:
4 1.13 christos # POSTFIXSOURCE/mantools/srctoman - makedefs | nroff -man
5 1.13 christos
6 1.1 tron #++
7 1.1 tron # NAME
8 1.1 tron # makedefs 1
9 1.1 tron # SUMMARY
10 1.12 christos # Postfix makefile configuration utility
11 1.1 tron # SYNOPSIS
12 1.1 tron # \fBmake makefiles \fIname=value...\fR
13 1.1 tron # DESCRIPTION
14 1.1 tron # The \fBmakedefs\fR command identifies the compilation
15 1.12 christos # environment, and emits macro definitions on the standard
16 1.12 christos # output stream that can be prepended to template Makefiles.
17 1.12 christos # These macros implement an internal interface and are subject
18 1.12 christos # to change without notice.
19 1.13 christos # NAME=VALUE OVERRIDES
20 1.13 christos # .ad
21 1.13 christos # .fi
22 1.1 tron # Default settings can be overruled by specifying them as
23 1.12 christos # environment variables (or as name=value pairs on the "make"
24 1.12 christos # command line). Use quotes if variables contain whitespace
25 1.12 christos # or shell meta characters.
26 1.12 christos #
27 1.13 christos # The command "\fBmake makefiles name=value...\fR" will replace
28 1.13 christos # the string \fBMAIL_VERSION\fR at the end of a value with the
29 1.13 christos # Postfix version (\fImajor.minor.patchlevel\fR for a stable
30 1.13 christos # release, \fImajor.minor-date\fR for a development release).
31 1.13 christos # Do not try to specify something like \fB$mail_version\fR:
32 1.13 christos # that produces inconsistent results with different implementations
33 1.13 christos # of the make(1) command.
34 1.1 tron # .IP \fBAUXLIBS=\fIobject_library...\fR
35 1.12 christos # Specifies one or more non-default object libraries. Postfix
36 1.13 christos # 3.0 and later specify some of their database library
37 1.12 christos # dependencies with AUXLIBS_CDB, AUXLIBS_LDAP, AUXLIBS_LMDB,
38 1.12 christos # AUXLIBS_MYSQL, AUXLIBS_PCRE, AUXLIBS_PGSQL, AUXLIBS_SDBM,
39 1.12 christos # and AUXLIBS_SQLITE, respectively.
40 1.1 tron # .IP \fBCC=\fIcompiler_command\fR
41 1.1 tron # Specifies a non-default compiler. On many systems, the default
42 1.1 tron # is \fBgcc\fR.
43 1.1 tron # .IP \fBCCARGS=\fIcompiler_arguments\fR
44 1.1 tron # Specifies non-default compiler arguments, for example, a non-default
45 1.1 tron # \fIinclude\fR directory.
46 1.1 tron # The following directives are special:
47 1.1 tron # .RS
48 1.7 tron # .IP \fB-DNO_DB\fR
49 1.7 tron # Do not build with Berkeley DB support.
50 1.1 tron # .IP \fB-DNO_DEVPOLL\fR
51 1.1 tron # Do not build with Solaris /dev/poll support.
52 1.1 tron # By default, /dev/poll support is compiled in on platforms that
53 1.1 tron # are known to support it.
54 1.12 christos # .IP \fB-DNO_DNSSEC\fR
55 1.12 christos # Do not build with DNSSEC support, even if the resolver
56 1.12 christos # library appears to support it.
57 1.1 tron # .IP \fB-DNO_EPOLL\fR
58 1.1 tron # Do not build with Linux EPOLL support.
59 1.1 tron # By default, EPOLL support is compiled in on platforms that
60 1.1 tron # are known to support it.
61 1.12 christos # .IP \fB-DNO_EAI\fR
62 1.12 christos # Do not build with EAI (SMTPUTF8) support. By default, EAI
63 1.13 christos # support is compiled in when the "pkg-config" command is
64 1.13 christos # found, or the deprecated "icu-config" command.
65 1.12 christos # .IP \fB-DNO_INLINE\fR
66 1.12 christos # Do not require support for C99 "inline" functions. Instead,
67 1.13 christos # implement argument typechecks for non-(printf/scanf)-like
68 1.12 christos # functions with ternary operators and unreachable code.
69 1.1 tron # .IP \fB-DNO_IPV6\fR
70 1.1 tron # Do not build with IPv6 support.
71 1.1 tron # By default, IPv6 support is compiled in on platforms that
72 1.1 tron # are known to have IPv6 support.
73 1.1 tron #
74 1.1 tron # Note: this directive is for debugging and testing only. It
75 1.13 christos # is not guaranteed to work on all platforms. If you don't
76 1.13 christos # want IPv6 support, set "inet_protocols = ipv4" in main.cf.
77 1.13 christos # .IP \fB-DNO_IP_CYRUS_SASL_AUTH\fR
78 1.13 christos # Don't pass remote SMTP client and Postfix SMTP server IP
79 1.13 christos # address and port information to the Cyrus SASL library.
80 1.13 christos # This is compatible with Postfix < 3.2.
81 1.1 tron # .IP \fB-DNO_KQUEUE\fR
82 1.1 tron # Do not build with FreeBSD/NetBSD/OpenBSD/MacOSX KQUEUE support.
83 1.1 tron # By default, KQUEUE support is compiled in on platforms that
84 1.1 tron # are known to support it.
85 1.7 tron # .IP \fB-DNO_NIS\fR
86 1.7 tron # Do not build with NIS or NISPLUS support. Support for NIS
87 1.9 tron # is unavailable on some recent Linux distributions.
88 1.9 tron # .IP \fB-DNO_NISPLUS\fR
89 1.9 tron # Do not build with NISPLUS support. Support for NISPLUS
90 1.9 tron # is unavailable on some recent Solaris distributions.
91 1.1 tron # .IP \fB-DNO_PCRE\fR
92 1.1 tron # Do not build with PCRE support.
93 1.1 tron # By default, PCRE support is compiled in when the \fBpcre-config\fR
94 1.1 tron # utility is installed.
95 1.7 tron # .IP \fB-DNO_POSIX_GETPW_R\fR
96 1.7 tron # Disable support for POSIX getpwnam_r/getpwuid_r.
97 1.1 tron # .IP \fB-DNO_SIGSETJMP\fR
98 1.1 tron # Use setjmp()/longjmp() instead of sigsetjmp()/siglongjmp().
99 1.1 tron # By default, Postfix uses sigsetjmp()/siglongjmp() when they
100 1.1 tron # appear to work.
101 1.13 christos # .IP \fB-DNO_SNPRINTF\fR
102 1.13 christos # Use sprintf() instead of snprintf(). By default, Postfix
103 1.13 christos # uses snprintf() except on ancient systems.
104 1.1 tron # .RE
105 1.1 tron # .IP \fBDEBUG=\fIdebug_level\fR
106 1.1 tron # Specifies a non-default debugging level. The default is \fB-g\fR.
107 1.1 tron # Specify \fBDEBUG=\fR to turn off debugging.
108 1.1 tron # .IP \fBOPT=\fIoptimization_level\fR
109 1.1 tron # Specifies a non-default optimization level. The default is \fB-O\fR.
110 1.1 tron # Specify \fBOPT=\fR to turn off optimization.
111 1.13 christos # .IP \fBPOSTFIX_INSTALL_OPTS=\fI-option...\fR
112 1.13 christos # Specifies options for the postfix-install command, separated
113 1.13 christos # by whitespace. Currently, the only supported option is
114 1.13 christos # \fB-keep-build-mtime\fR.
115 1.12 christos # .IP \fBSHLIB_CFLAGS=\fIflags\fR
116 1.12 christos # Override the compiler flags (typically, "-fPIC") for Postfix
117 1.12 christos # dynamically-linked libraries and database plugins.
118 1.12 christos #
119 1.12 christos # This feature was introduced with Postfix 3.0.
120 1.12 christos # .IP \fBSHLIB_RPATH=\fIrpath\fR
121 1.12 christos # Override the runpath (typically, "'-Wl,-rpath,${SHLIB_DIR}'")
122 1.12 christos # for Postfix dynamically-linked libraries.
123 1.12 christos #
124 1.12 christos # This feature was introduced with Postfix 3.0.
125 1.12 christos # .IP \fBSHLIB_SUFFIX=\fIsuffix\fR
126 1.12 christos # Override the filename suffix (typically, ".so") for Postfix
127 1.12 christos # dynamically-linked libraries and database plugins.
128 1.12 christos #
129 1.12 christos # This feature was introduced with Postfix 3.0.
130 1.12 christos # .IP \fBshared=yes\fR
131 1.12 christos # .IP \fBshared=no\fR
132 1.12 christos # Enable (disable) Postfix builds with dynamically-linked
133 1.12 christos # libraries typically named $shlib_directory/libpostfix-*.so.*.
134 1.12 christos #
135 1.12 christos # This feature was introduced with Postfix 3.0.
136 1.12 christos # .IP \fBdynamicmaps=yes\fR
137 1.12 christos # .IP \fBdynamicmaps=no\fR
138 1.12 christos # Enable (disable) Postfix builds with the configuration file
139 1.12 christos # $meta_directory/dynamicmaps.cf and dynamically-loadable
140 1.12 christos # database plugins typically named postfix-*.so.*. The setting
141 1.12 christos # "dynamicmaps=yes" implicitly enables Postfix dynamically-linked
142 1.12 christos # libraries.
143 1.12 christos #
144 1.12 christos # This feature was introduced with Postfix 3.0.
145 1.12 christos # .IP \fBpie=yes\fR
146 1.12 christos # .IP \fBpie=no\fR
147 1.12 christos # Enable (disable) Postfix builds with position-independent
148 1.12 christos # executables, on platforms where this is supported.
149 1.12 christos #
150 1.12 christos # This feature was introduced with Postfix 3.0.
151 1.12 christos # .IP \fIinstallation_parameter\fB=\fIvalue\fR...
152 1.12 christos # Override the compiled-in default value of the specified
153 1.12 christos # installation parameter(s). The following parameters are
154 1.12 christos # supported in this context:
155 1.12 christos #
156 1.12 christos # command_directory config_directory daemon_directory
157 1.12 christos # data_directory default_database_type html_directory
158 1.12 christos # mail_spool_directory mailq_path manpage_directory meta_directory
159 1.12 christos # newaliases_path queue_directory readme_directory sendmail_path
160 1.12 christos # shlib_directory openssl_path
161 1.12 christos #
162 1.12 christos # See the postconf(5) manpage for a description of these
163 1.12 christos # parameters.
164 1.12 christos #
165 1.12 christos # This feature was introduced with Postfix 3.0.
166 1.1 tron # .IP \fBWARN=\fIwarning_flags\fR
167 1.1 tron # Specifies non-default gcc compiler warning options for use when
168 1.1 tron # "make" is invoked in a source subdirectory only.
169 1.1 tron # LICENSE
170 1.1 tron # .ad
171 1.1 tron # .fi
172 1.1 tron # The Secure Mailer license must be distributed with this software.
173 1.1 tron # AUTHOR(S)
174 1.1 tron # Wietse Venema
175 1.1 tron # IBM T.J. Watson Research
176 1.1 tron # P.O. Box 704
177 1.1 tron # Yorktown Heights, NY 10598, USA
178 1.12 christos #
179 1.12 christos # Wietse Venema
180 1.12 christos # Google, Inc.
181 1.12 christos # 111 8th Avenue
182 1.12 christos # New York, NY 10011, USA
183 1.1 tron #--
184 1.1 tron
185 1.1 tron # Emit system-dependent Makefile macro definitions to standard output.
186 1.1 tron
187 1.12 christos echo "#----------------------------------------------------------------"
188 1.12 christos echo "# Start of summary of user-configurable 'make makefiles' options."
189 1.12 christos echo "# CCARGS=$CCARGS"
190 1.12 christos echo "# AUXLIBS=$AUXLIBS"
191 1.12 christos env | grep '^AUXLIBS_' | sed 's/^/# /'
192 1.12 christos echo "# shared=$shared"
193 1.12 christos echo "# dynamicmaps=$dynamicmaps"
194 1.12 christos echo "# pie=$pie"
195 1.12 christos
196 1.1 tron # Defaults for most sane systems
197 1.1 tron
198 1.1 tron RANLIB=ranlib
199 1.1 tron SYSLIBS=
200 1.1 tron AR=ar
201 1.1 tron ARFL=rv
202 1.1 tron
203 1.1 tron # Ugly function to make our error message more visible among the
204 1.1 tron # garbage that is output by some versions of make(1).
205 1.1 tron
206 1.1 tron # By now all shells must have functions.
207 1.1 tron
208 1.1 tron error() {
209 1.1 tron # Alas, tput(1) is not portable so we can't use visual effects.
210 1.1 tron echo "ATTENTION:" 1>&2;
211 1.1 tron echo "ATTENTION:" $* 1>&2;
212 1.1 tron echo "ATTENTION:" 1>&2;
213 1.1 tron exit 1
214 1.1 tron }
215 1.1 tron
216 1.1 tron case $# in
217 1.1 tron # Officially supported usage.
218 1.1 tron 0) SYSTEM=`(uname -s) 2>/dev/null`
219 1.1 tron RELEASE=`(uname -r) 2>/dev/null`
220 1.11 tron # No ${x%%y} support in Solaris 11 /bin/sh
221 1.11 tron RELEASE_MAJOR=`expr "$RELEASE" : '\([0-9]*\)'` || exit 1
222 1.1 tron VERSION=`(uname -v) 2>/dev/null`
223 1.1 tron case "$VERSION" in
224 1.1 tron dcosx*) SYSTEM=$VERSION;;
225 1.1 tron esac;;
226 1.1 tron # Unsupported debug-only mode. Not suitable for cross-platform tests.
227 1.1 tron 2) SYSTEM="$1"; RELEASE="$2";;
228 1.1 tron *) echo usage: $0 [system release] 1>&2; exit 1;;
229 1.1 tron esac
230 1.1 tron
231 1.14 christos case "$SYSTEM" in
232 1.14 christos Linux)
233 1.14 christos case "`PATH=/bin:/usr/bin ldd /bin/sh`" in
234 1.14 christos *-musl-*)
235 1.14 christos case "$CCARGS" in
236 1.14 christos *-DNO_DNSSEC*) ;;
237 1.14 christos *) echo Warning: libc-musl breaks DANE/TLSA security. 1>&2
238 1.14 christos echo This build will not support DANE/TLSA. 1>&2
239 1.14 christos CCARGS="$CCARGS -DNO_DNSSEC";;
240 1.14 christos esac;;
241 1.14 christos esac;;
242 1.14 christos esac
243 1.14 christos
244 1.1 tron case "$SYSTEM.$RELEASE" in
245 1.1 tron SCO_SV.3.2) SYSTYPE=SCO5
246 1.1 tron # Use the native compiler by default
247 1.1 tron : ${CC="/usr/bin/cc -b elf"}
248 1.1 tron CCARGS="$CCARGS -DPIPES_CANT_FIONREAD $CCARGS"
249 1.1 tron SYSLIBS="-lsocket -ldbm"
250 1.1 tron RANLIB=echo
251 1.1 tron ;;
252 1.1 tron UnixWare.5*) SYSTYPE=UW7
253 1.1 tron # Use the native compiler by default
254 1.1 tron : ${CC=/usr/bin/cc}
255 1.1 tron RANLIB=echo
256 1.1 tron SYSLIBS="-lresolv -lsocket -lnsl"
257 1.1 tron ;;
258 1.1 tron UNIX_SV.4.2*) case "`uname -v`" in
259 1.1 tron 2.1*) SYSTYPE=UW21
260 1.1 tron # Use the native compiler by default
261 1.1 tron : ${CC=/usr/bin/cc}
262 1.1 tron RANLIB=echo
263 1.1 tron SYSLIBS="-lresolv -lsocket -lnsl -lc -L/usr/ucblib -lucb"
264 1.1 tron ;;
265 1.1 tron *) error "Seems to be UnixWare`uname -v`. Untested.";;
266 1.1 tron esac
267 1.1 tron ;;
268 1.1 tron FreeBSD.2*) SYSTYPE=FREEBSD2
269 1.1 tron ;;
270 1.1 tron FreeBSD.3*) SYSTYPE=FREEBSD3
271 1.1 tron ;;
272 1.1 tron FreeBSD.4*) SYSTYPE=FREEBSD4
273 1.1 tron ;;
274 1.1 tron FreeBSD.5*) SYSTYPE=FREEBSD5
275 1.1 tron ;;
276 1.1 tron FreeBSD.6*) SYSTYPE=FREEBSD6
277 1.1 tron ;;
278 1.1 tron FreeBSD.7*) SYSTYPE=FREEBSD7
279 1.1 tron ;;
280 1.2 christos FreeBSD.8*) SYSTYPE=FREEBSD8
281 1.12 christos : ${SHLIB_SUFFIX=.so}
282 1.12 christos : ${SHLIB_CFLAGS=-fPIC}
283 1.12 christos : ${SHLIB_LD="${CC-gcc} -shared"' -Wl,-soname,${LIB}'}
284 1.12 christos : ${SHLIB_RPATH='-Wl,-rpath,${SHLIB_DIR}'}
285 1.12 christos : ${SHLIB_ENV="LD_LIBRARY_PATH=`pwd`/lib"}
286 1.12 christos : ${PLUGIN_LD="${CC-gcc} -shared"}
287 1.2 christos ;;
288 1.6 tron FreeBSD.9*) SYSTYPE=FREEBSD9
289 1.12 christos : ${SHLIB_SUFFIX=.so}
290 1.12 christos : ${SHLIB_CFLAGS=-fPIC}
291 1.12 christos : ${SHLIB_LD="${CC-gcc} -shared"' -Wl,-soname,${LIB}'}
292 1.12 christos : ${SHLIB_RPATH='-Wl,-rpath,${SHLIB_DIR}'}
293 1.12 christos : ${SHLIB_ENV="LD_LIBRARY_PATH=`pwd`/lib"}
294 1.12 christos : ${PLUGIN_LD="${CC-gcc} -shared"}
295 1.6 tron ;;
296 1.11 tron FreeBSD.10*) SYSTYPE=FREEBSD10
297 1.11 tron : ${CC=cc}
298 1.12 christos : ${SHLIB_SUFFIX=.so}
299 1.12 christos : ${SHLIB_CFLAGS=-fPIC}
300 1.12 christos : ${SHLIB_LD="${CC} -shared"' -Wl,-soname,${LIB}'}
301 1.12 christos : ${SHLIB_RPATH='-Wl,-rpath,${SHLIB_DIR}'}
302 1.12 christos : ${SHLIB_ENV="LD_LIBRARY_PATH=`pwd`/lib"}
303 1.12 christos : ${PLUGIN_LD="${CC} -shared"}
304 1.11 tron ;;
305 1.13 christos FreeBSD.11*) SYSTYPE=FREEBSD11
306 1.13 christos : ${CC=cc}
307 1.13 christos : ${SHLIB_SUFFIX=.so}
308 1.13 christos : ${SHLIB_CFLAGS=-fPIC}
309 1.13 christos : ${SHLIB_LD="${CC} -shared"' -Wl,-soname,${LIB}'}
310 1.13 christos : ${SHLIB_RPATH='-Wl,-rpath,${SHLIB_DIR}'}
311 1.13 christos : ${SHLIB_ENV="LD_LIBRARY_PATH=`pwd`/lib"}
312 1.13 christos : ${PLUGIN_LD="${CC} -shared"}
313 1.13 christos ;;
314 1.9 tron DragonFly.*) SYSTYPE=DRAGONFLY
315 1.9 tron ;;
316 1.1 tron OpenBSD.2*) SYSTYPE=OPENBSD2
317 1.1 tron ;;
318 1.1 tron OpenBSD.3*) SYSTYPE=OPENBSD3
319 1.1 tron ;;
320 1.1 tron OpenBSD.4*) SYSTYPE=OPENBSD4
321 1.1 tron ;;
322 1.5 tron OpenBSD.5*) SYSTYPE=OPENBSD5
323 1.12 christos : ${CC=cc}
324 1.12 christos : ${SHLIB_SUFFIX=.so.1.0}
325 1.12 christos : ${SHLIB_CFLAGS=-fPIC}
326 1.12 christos : ${SHLIB_LD="${CC} -shared"' -Wl,-soname,${LIB}'}
327 1.12 christos : ${SHLIB_RPATH='-Wl,-rpath,${SHLIB_DIR}'}
328 1.12 christos : ${SHLIB_ENV="LD_LIBRARY_PATH=`pwd`/lib"}
329 1.12 christos : ${PLUGIN_LD="${CC} -shared"}
330 1.12 christos ;;
331 1.12 christos OpenBSD.6*) SYSTYPE=OPENBSD6
332 1.12 christos : ${CC=cc}
333 1.12 christos : ${SHLIB_SUFFIX=.so.1.0}
334 1.12 christos : ${SHLIB_CFLAGS=-fPIC}
335 1.12 christos : ${SHLIB_LD="${CC} -shared"' -Wl,-soname,${LIB}'}
336 1.12 christos : ${SHLIB_RPATH='-Wl,-rpath,${SHLIB_DIR}'}
337 1.12 christos : ${SHLIB_ENV="LD_LIBRARY_PATH=`pwd`/lib"}
338 1.12 christos : ${PLUGIN_LD="${CC} -shared"}
339 1.5 tron ;;
340 1.1 tron ekkoBSD.1*) SYSTYPE=EKKOBSD1
341 1.1 tron ;;
342 1.1 tron NetBSD.1*) SYSTYPE=NETBSD1
343 1.1 tron ;;
344 1.1 tron NetBSD.2*) SYSTYPE=NETBSD2
345 1.1 tron ;;
346 1.1 tron NetBSD.3*) SYSTYPE=NETBSD3
347 1.1 tron ;;
348 1.1 tron NetBSD.4*) SYSTYPE=NETBSD4
349 1.1 tron ;;
350 1.2 christos NetBSD.5*) SYSTYPE=NETBSD5
351 1.2 christos ;;
352 1.9 tron NetBSD.6*) SYSTYPE=NETBSD6
353 1.12 christos : ${SHLIB_SUFFIX=.so}
354 1.12 christos : ${SHLIB_CFLAGS=-fPIC}
355 1.12 christos : ${SHLIB_LD="${CC-gcc} -shared"' -Wl,-soname,${LIB}'}
356 1.12 christos : ${SHLIB_RPATH='-Wl,-rpath,${SHLIB_DIR}'}
357 1.12 christos : ${SHLIB_ENV="LD_LIBRARY_PATH=`pwd`/lib"}
358 1.12 christos : ${PLUGIN_LD="${CC-gcc} -shared"}
359 1.12 christos ;;
360 1.12 christos NetBSD.7*) SYSTYPE=NETBSD7
361 1.12 christos : ${SHLIB_SUFFIX=.so}
362 1.12 christos : ${SHLIB_CFLAGS=-fPIC}
363 1.12 christos : ${SHLIB_LD="${CC-gcc} -shared"' -Wl,-soname,${LIB}'}
364 1.12 christos : ${SHLIB_RPATH='-Wl,-rpath,${SHLIB_DIR}'}
365 1.12 christos : ${SHLIB_ENV="LD_LIBRARY_PATH=`pwd`/lib"}
366 1.12 christos : ${PLUGIN_LD="${CC-gcc} -shared"}
367 1.9 tron ;;
368 1.1 tron BSD/OS.2*) SYSTYPE=BSDI2
369 1.1 tron ;;
370 1.1 tron BSD/OS.3*) SYSTYPE=BSDI3
371 1.1 tron ;;
372 1.1 tron BSD/OS.4*) SYSTYPE=BSDI4
373 1.1 tron ;;
374 1.1 tron OSF1.V[3-5].*) SYSTYPE=OSF1
375 1.1 tron # Use the native compiler by default
376 1.1 tron : ${CC=cc}
377 1.1 tron : ${DEBUG="-g3"}
378 1.1 tron case $RELEASE in
379 1.1 tron V[0-4].*) CCARGS="$CCARGS -DNO_IPV6";;
380 1.1 tron esac
381 1.1 tron ;;
382 1.1 tron SunOS.4*) SYSTYPE=SUNOS4
383 1.1 tron SYSLIBS=-lresolv
384 1.1 tron ;;
385 1.1 tron SunOS.5*) SYSTYPE=SUNOS5
386 1.1 tron RANLIB=echo
387 1.9 tron SYSLIBS="-lresolv -lsocket -lnsl -ldl"
388 1.12 christos : ${SHLIB_SUFFIX=.so}
389 1.12 christos : ${SHLIB_CFLAGS=-fPIC}
390 1.12 christos : ${SHLIB_LD="${CC-gcc} -shared"' -Wl,-h,${LIB}'}
391 1.12 christos : ${SHLIB_ENV="LD_LIBRARY_PATH=`pwd`/lib"}
392 1.12 christos : ${SHLIB_RPATH='-Wl,-R,${SHLIB_DIR}'}
393 1.12 christos : ${PLUGIN_LD="${CC-gcc} -shared"}
394 1.1 tron # Stock awk breaks with >10 files.
395 1.1 tron test -x /usr/xpg4/bin/awk && AWK=/usr/xpg4/bin/awk
396 1.7 tron # Solaris 2.5 added usleep(), POSIX regexp, POSIX getpwnam/uid_r
397 1.1 tron case $RELEASE in
398 1.7 tron 5.[0-4]) CCARGS="$CCARGS -DMISSING_USLEEP -DNO_POSIX_REGEXP -DNO_POSIX_GETPW_R";;
399 1.1 tron esac
400 1.13 christos # Solaris 2.6 added snprintf()
401 1.13 christos case $RELEASE in
402 1.13 christos 5.[0-5]) CCARGS="$CCARGS -DNO_SNPRINTF";;
403 1.13 christos esac
404 1.1 tron # Solaris 8 added IPv6 and /dev/poll
405 1.1 tron case $RELEASE in
406 1.1 tron 5.[0-7]|5.[0-7].*) CCARGS="$CCARGS -DNO_IPV6 -DNO_DEVPOLL";;
407 1.1 tron esac
408 1.1 tron # Solaris 9 added closefrom(), futimesat() and /dev/*random
409 1.8 tron # and appears to have solid UNIX-domain sockets.
410 1.1 tron case $RELEASE in
411 1.8 tron 5.[0-8]|5.[0-8].*) CCARGS="$CCARGS -DNO_CLOSEFROM -DNO_DEV_URANDOM -DNO_FUTIMESAT -DSTREAM_CONNECTIONS";;
412 1.1 tron esac
413 1.13 christos # Solaris 10 added setenv(), unsetenv().
414 1.13 christos case $RELEASE in
415 1.13 christos 5.[0-9]|5.[0-9].*) CCARGS="$CCARGS -DMISSING_SETENV";;
416 1.13 christos esac
417 1.13 christos # NISPLUS was removed after Solaris 10.
418 1.9 tron case $RELEASE in
419 1.9 tron 5.[0-9][0-9]*) CCARGS="$CCARGS -DNO_NISPLUS";;
420 1.9 tron esac
421 1.1 tron # Work around broken str*casecmp(). Do it all here instead
422 1.1 tron # of having half the solution in the sys_defs.h file.
423 1.1 tron CCARGS="$CCARGS -Dstrcasecmp=fix_strcasecmp \
424 1.1 tron -Dstrncasecmp=fix_strncasecmp"
425 1.1 tron STRCASE="strcasecmp.o"
426 1.1 tron # Avoid common types of braindamage
427 1.1 tron case "$LD_LIBRARY_PATH" in
428 1.1 tron ?*) error "Don't set LD_LIBRARY_PATH";;
429 1.1 tron esac
430 1.1 tron case "${CC}" in
431 1.1 tron *" "*) ;;
432 1.1 tron *ucb*) error "Don't use /usr/ucb/cc or ucblib";;
433 1.1 tron cc*) case `which ${CC}` in
434 1.1 tron *ucb*) error "Don't use /usr/ucb/cc or ucblib";;
435 1.1 tron esac;;
436 1.1 tron esac
437 1.1 tron ;;
438 1.1 tron ULTRIX.4*) SYSTYPE=ULTRIX4
439 1.1 tron if [ -f /usr/local/lib/libdb.a ]; then
440 1.1 tron SYSLIBS="$SYSLIBS -ldb"
441 1.1 tron CCARGS="$CCARGS -DHAS_DB"
442 1.1 tron if [ -d /usr/local/include/db ]; then
443 1.1 tron CCARGS="$CCARGS -I/usr/local/include/db"
444 1.1 tron fi
445 1.1 tron fi
446 1.1 tron for l in syslog resolv; do
447 1.1 tron if [ -f /usr/local/lib/lib$l.a ]; then
448 1.1 tron SYSLIBS="$SYSLIBS -l$l"
449 1.1 tron fi
450 1.1 tron done
451 1.1 tron ;;
452 1.1 tron AIX.*) case "`uname -v`" in
453 1.3 tron 6) SYSTYPE=AIX6
454 1.12 christos CCARGS="$CCARGS -DNO_DNSSEC"
455 1.3 tron case "$CC" in
456 1.3 tron cc|*/cc|xlc|*/xlc) CCARGS="$CCARGS -w -blibpath:/usr/lib:/lib:/usr/local/lib";;
457 1.3 tron esac
458 1.3 tron CCARGS="$CCARGS -D_ALL_SOURCE -DHAS_POSIX_REGEXP"
459 1.3 tron ;;
460 1.1 tron 5) SYSTYPE=AIX5
461 1.12 christos CCARGS="$CCARGS -DNO_DNSSEC"
462 1.1 tron case "$CC" in
463 1.1 tron cc|*/cc|xlc|*/xlc) CCARGS="$CCARGS -w -blibpath:/usr/lib:/lib:/usr/local/lib";;
464 1.1 tron esac
465 1.1 tron CCARGS="$CCARGS -D_ALL_SOURCE -DHAS_POSIX_REGEXP"
466 1.1 tron ;;
467 1.1 tron 4) SYSTYPE=AIX4
468 1.12 christos CCARGS="$CCARGS -DNO_DNSSEC"
469 1.1 tron # How embarrassing...
470 1.1 tron case "$CC" in
471 1.1 tron cc|*/cc|xlc|*/xlc) OPT=; CCARGS="$CCARGS -w -blibpath:/usr/lib:/lib:/usr/local/lib";;
472 1.1 tron esac
473 1.1 tron CCARGS="$CCARGS -D_ALL_SOURCE -DHAS_POSIX_REGEXP"
474 1.1 tron ;;
475 1.1 tron 3) SYSTYPE=AIX3
476 1.12 christos CCARGS="$CCARGS -DNO_DNSSEC"
477 1.1 tron # How embarrassing...
478 1.1 tron case "$CC" in
479 1.1 tron cc|*/cc|xlc|*/xlc) OPT=; CCARGS="$CCARGS -w";;
480 1.1 tron esac
481 1.1 tron CCARGS="$CCARGS -D_ALL_SOURCE"
482 1.1 tron ;;
483 1.1 tron *) error "Unknown AIX version: `uname -v`.";;
484 1.1 tron esac;;
485 1.1 tron # Tested with RedHat 3.03 on 20020729.
486 1.1 tron Linux.1*) SYSTYPE=LINUX1
487 1.8 tron case "$CCARGS" in
488 1.8 tron *-DNO_DB*) ;;
489 1.9 tron *-DHAS_DB*) ;;
490 1.8 tron *) SYSLIBS="-ldb";;
491 1.8 tron esac
492 1.1 tron ;;
493 1.1 tron Linux.2*) SYSTYPE=LINUX2
494 1.8 tron case "$CCARGS" in
495 1.8 tron *-DNO_DB*) ;;
496 1.9 tron *-DHAS_DB*) ;;
497 1.8 tron *) if [ -f /usr/include/db.h ]
498 1.8 tron then
499 1.8 tron : we are all set
500 1.8 tron elif [ -f /usr/include/db/db.h ]
501 1.8 tron then
502 1.8 tron CCARGS="$CCARGS -I/usr/include/db"
503 1.8 tron else
504 1.8 tron # No, we're not going to try db1 db2 db3 etc.
505 1.8 tron # On a properly installed system, Postfix builds
506 1.8 tron # by including <db.h> and by linking with -ldb
507 1.8 tron echo "No <db.h> include file found." 1>&2
508 1.8 tron echo "Install the appropriate db*-devel package first." 1>&2
509 1.8 tron exit 1
510 1.8 tron fi
511 1.8 tron SYSLIBS="-ldb"
512 1.8 tron ;;
513 1.8 tron esac
514 1.1 tron for name in nsl resolv $GDBM_LIBS
515 1.1 tron do
516 1.1 tron for lib in /usr/lib64 /lib64 /usr/lib /lib
517 1.1 tron do
518 1.1 tron test -e $lib/lib$name.a -o -e $lib/lib$name.so && {
519 1.1 tron SYSLIBS="$SYSLIBS -l$name"
520 1.1 tron break
521 1.1 tron }
522 1.1 tron done
523 1.1 tron done
524 1.1 tron # Kernel 2.4 added IPv6
525 1.1 tron case "$RELEASE" in
526 1.1 tron 2.[0-3].*) CCARGS="$CCARGS -DNO_IPV6";;
527 1.1 tron esac
528 1.1 tron # Kernel 2.6 added EPOLL
529 1.1 tron case "$RELEASE" in
530 1.1 tron 2.[0-5].*) CCARGS="$CCARGS -DNO_EPOLL";;
531 1.1 tron # Workaround for retarded libc
532 1.2 christos 2.6.*)
533 1.2 christos if [ `expr "X$CCARGS" : "X.*-DNO_EPOLL"` -gt 0 ]
534 1.9 tron then
535 1.9 tron :
536 1.9 tron elif [ ! -e /usr/include/sys/epoll.h ]
537 1.9 tron then
538 1.9 tron echo CCARGS="$CCARGS -DNO_EPOLL"
539 1.9 tron else
540 1.2 christos trap 'rm -f makedefs.test makedefs.test.[co]' 1 2 3 15
541 1.1 tron cat >makedefs.test.c <<'EOF'
542 1.1 tron #include <sys/types.h>
543 1.1 tron #include <sys/epoll.h>
544 1.1 tron #include <errno.h>
545 1.1 tron #include <stdio.h>
546 1.1 tron #include <stdlib.h>
547 1.1 tron
548 1.1 tron int main(int argc, char **argv)
549 1.1 tron {
550 1.1 tron int epoll_handle;
551 1.1 tron
552 1.1 tron if ((epoll_handle = epoll_create(1)) < 0) {
553 1.1 tron perror("epoll_create");
554 1.1 tron exit(1);
555 1.1 tron }
556 1.1 tron exit(0);
557 1.1 tron }
558 1.1 tron EOF
559 1.1 tron ${CC-gcc} -o makedefs.test makedefs.test.c || exit 1
560 1.1 tron ./makedefs.test 2>/dev/null ||
561 1.1 tron CCARGS="$CCARGS -DNO_EPOLL"
562 1.2 christos rm -f makedefs.test makedefs.test.[co]
563 1.2 christos fi;;
564 1.1 tron esac
565 1.12 christos SYSLIBS="$SYSLIBS -ldl"
566 1.12 christos : ${SHLIB_SUFFIX=.so}
567 1.12 christos : ${SHLIB_CFLAGS=-fPIC}
568 1.12 christos : ${SHLIB_LD="${CC-gcc} -shared"' -Wl,-soname,${LIB}'}
569 1.12 christos : ${SHLIB_RPATH='-Wl,--enable-new-dtags -Wl,-rpath,${SHLIB_DIR}'}
570 1.12 christos : ${SHLIB_ENV="LD_LIBRARY_PATH=`pwd`/lib"}
571 1.12 christos : ${PLUGIN_LD="${CC-gcc} -shared"}
572 1.1 tron ;;
573 1.13 christos Linux.[345].*) SYSTYPE=LINUX$RELEASE_MAJOR
574 1.8 tron case "$CCARGS" in
575 1.8 tron *-DNO_DB*) ;;
576 1.9 tron *-DHAS_DB*) ;;
577 1.8 tron *) if [ -f /usr/include/db.h ]
578 1.8 tron then
579 1.8 tron : we are all set
580 1.8 tron elif [ -f /usr/include/db/db.h ]
581 1.8 tron then
582 1.8 tron CCARGS="$CCARGS -I/usr/include/db"
583 1.8 tron else
584 1.8 tron # On a properly installed system, Postfix builds
585 1.8 tron # by including <db.h> and by linking with -ldb
586 1.8 tron echo "No <db.h> include file found." 1>&2
587 1.8 tron echo "Install the appropriate db*-devel package first." 1>&2
588 1.8 tron exit 1
589 1.8 tron fi
590 1.8 tron SYSLIBS="-ldb"
591 1.8 tron ;;
592 1.8 tron esac
593 1.4 tron for name in nsl resolv
594 1.4 tron do
595 1.8 tron for lib in /usr/lib64 /lib64 /usr/lib /usr/lib/* /lib /lib/*
596 1.4 tron do
597 1.4 tron test -e $lib/lib$name.a -o -e $lib/lib$name.so && {
598 1.4 tron SYSLIBS="$SYSLIBS -l$name"
599 1.4 tron break
600 1.4 tron }
601 1.4 tron done
602 1.4 tron done
603 1.12 christos SYSLIBS="$SYSLIBS -ldl"
604 1.12 christos : ${SHLIB_SUFFIX=.so}
605 1.12 christos : ${SHLIB_CFLAGS=-fPIC}
606 1.12 christos : ${SHLIB_LD="${CC-gcc} -shared"' -Wl,-soname,${LIB}'}
607 1.12 christos : ${SHLIB_RPATH='-Wl,--enable-new-dtags -Wl,-rpath,${SHLIB_DIR}'}
608 1.12 christos : ${SHLIB_ENV="LD_LIBRARY_PATH=`pwd`/lib"}
609 1.12 christos : ${PLUGIN_LD="${CC-gcc} -shared"}
610 1.4 tron ;;
611 1.1 tron GNU.0*|GNU/kFreeBSD.[567]*)
612 1.9 tron SYSTYPE=GNU0
613 1.8 tron case "$CCARGS" in
614 1.8 tron *-DNO_DB*) ;;
615 1.8 tron *) if [ -f /usr/include/db.h ]
616 1.8 tron then
617 1.8 tron : we are all set
618 1.8 tron elif [ -f /usr/include/db/db.h ]
619 1.8 tron then
620 1.8 tron CCARGS="$CCARGS -I/usr/include/db"
621 1.8 tron else
622 1.8 tron # On a properly installed system, Postfix builds
623 1.8 tron # by including <db.h> and by linking with -ldb
624 1.8 tron echo "No <db.h> include file found." 1>&2
625 1.8 tron echo "Install the appropriate db*-devel package first." 1>&2
626 1.8 tron exit 1
627 1.8 tron fi
628 1.8 tron SYSLIBS="-ldb"
629 1.8 tron ;;
630 1.8 tron esac
631 1.1 tron for name in nsl resolv
632 1.1 tron do
633 1.1 tron for lib in /usr/lib64 /lib64 /usr/lib /lib
634 1.1 tron do
635 1.1 tron test -e $lib/lib$name.a -o -e $lib/lib$name.so && {
636 1.1 tron SYSLIBS="$SYSLIBS -l$name"
637 1.1 tron break
638 1.1 tron }
639 1.1 tron done
640 1.1 tron done
641 1.1 tron case "`uname -s`" in
642 1.1 tron GNU)
643 1.1 tron # currently no IPv6 support on Hurd
644 1.1 tron CCARGS="$CCARGS -DNO_IPV6"
645 1.1 tron ;;
646 1.1 tron esac
647 1.1 tron ;;
648 1.1 tron IRIX*.5.*) SYSTYPE=IRIX5
649 1.1 tron # Use the native compiler by default
650 1.1 tron : ${CC=cc} ${DEBUG="-g3"}
651 1.1 tron RANLIB=echo
652 1.1 tron ;;
653 1.1 tron IRIX*.6.*) SYSTYPE=IRIX6
654 1.1 tron # Use the native compiler by default, and allow nested comments.
655 1.1 tron : ${CC="cc -woff 1009,1116,1412"}
656 1.1 tron RANLIB=echo
657 1.1 tron ;;
658 1.1 tron HP-UX.A.09.*) SYSTYPE=HPUX9
659 1.1 tron SYSLIBS=-ldbm
660 1.13 christos CCARGS="$CCARGS -DMISSING_USLEEP -DNO_SNPRINTF"
661 1.1 tron if [ -f /usr/lib/libdb.a ]; then
662 1.1 tron CCARGS="$CCARGS -DHAS_DB"
663 1.1 tron SYSLIBS="$SYSLIBS -ldb"
664 1.1 tron fi
665 1.1 tron ;;
666 1.1 tron HP-UX.B.10.*) SYSTYPE=HPUX10
667 1.1 tron CCARGS="$CCARGS `nm /usr/lib/libc.a 2>/dev/null |
668 1.1 tron (grep usleep >/dev/null || echo '-DMISSING_USLEEP')`"
669 1.13 christos CCARGS="$CCARGS -DNO_SNPRINTF"
670 1.1 tron if [ -f /usr/lib/libdb.a ]; then
671 1.1 tron CCARGS="$CCARGS -DHAS_DB"
672 1.1 tron SYSLIBS=-ldb
673 1.1 tron fi
674 1.1 tron ;;
675 1.1 tron HP-UX.B.11.*) SYSTYPE=HPUX11
676 1.1 tron SYSLIBS=-lnsl
677 1.1 tron if [ -f /usr/lib/libdb.a ]; then
678 1.1 tron CCARGS="$CCARGS -DHAS_DB"
679 1.1 tron SYSLIBS="$SYSLIBS -ldb"
680 1.1 tron fi
681 1.1 tron ;;
682 1.1 tron ReliantUNIX-?.5.43) SYSTYPE=ReliantUnix543
683 1.1 tron RANLIB=echo
684 1.1 tron SYSLIBS="-lresolv -lsocket -lnsl"
685 1.1 tron ;;
686 1.1 tron Darwin.*) SYSTYPE=MACOSX
687 1.1 tron # Use the native compiler by default
688 1.1 tron : ${CC=cc}
689 1.12 christos CCARGS="$CCARGS"
690 1.1 tron # Darwin > 1.3 uses awk and flat_namespace
691 1.1 tron case $RELEASE in
692 1.1 tron 1.[0-3]) AWK=gawk;;
693 1.1 tron *) AWK=awk
694 1.9 tron SYSLIBS="$SYSLIBS -flat_namespace";;
695 1.1 tron esac
696 1.1 tron # Darwin 7 adds IPv6 support, BIND_8_COMPAT, NO_NETINFO
697 1.1 tron case $RELEASE in
698 1.1 tron [1-6].*) CCARGS="$CCARGS -DNO_IPV6";;
699 1.1 tron *) CCARGS="$CCARGS -DBIND_8_COMPAT -DNO_NETINFO";;
700 1.1 tron esac
701 1.7 tron # Darwin 9.0 (MacOS X 10.5) adds POSIX getpwnam_r/getpwuid_r
702 1.7 tron case $RELEASE in
703 1.7 tron [1-8].*) CCARGS="$CCARGS -DNO_POSIX_GETPW_R";;
704 1.7 tron esac
705 1.2 christos # Darwin 10.3.0 no longer has <nameser8_compat.h>.
706 1.2 christos case $RELEASE in
707 1.2 christos ?.*) CCARGS="$CCARGS -DRESOLVE_H_NEEDS_NAMESER8_COMPAT_H";;
708 1.2 christos *) CCARGS="$CCARGS -DRESOLVE_H_NEEDS_ARPA_NAMESER_COMPAT_H";;
709 1.2 christos esac
710 1.10 tron # Darwin 11.x (MacOS X 10.7.x), maybe earlier, needs libresolv.
711 1.9 tron case $RELEASE in
712 1.10 tron ?.*|10.*) ;;
713 1.9 tron *) SYSLIBS="$SYSLIBS -lresolv";;
714 1.9 tron esac
715 1.9 tron # kqueue and/or poll are broken in MacOS X 10.5 (Darwin 9).
716 1.9 tron # kqueue works in Mac OS X 10.8 (Darwin 12).
717 1.9 tron case $RELEASE in
718 1.9 tron ?.*|1[0-1].*) CCARGS="$CCARGS -DNO_KQUEUE";;
719 1.9 tron esac
720 1.12 christos : ${SHLIB_CFLAGS=-fPIC}
721 1.12 christos : ${SHLIB_SUFFIX=.dylib}
722 1.12 christos : ${SHLIB_LD='cc -shared -Wl,-flat_namespace -Wl,-undefined,dynamic_lookup -Wl,-install_name,@rpath/${LIB}'}
723 1.12 christos : ${SHLIB_RPATH='-Wl,-rpath,${SHLIB_DIR}'}
724 1.12 christos # In MacOS/X 10.11.x /bin/sh unsets DYLD_LIBRARY_PATH, so we
725 1.12 christos # have export it into postfix-install indirectly!
726 1.12 christos : ${SHLIB_ENV="DYLD_LIBRARY_PATH=`pwd`/lib SHLIB_ENV_VAR=DYLD_LIBRARY_PATH SHLIB_ENV_VAL=`pwd`/lib"}
727 1.12 christos : ${PLUGIN_LD='cc -shared -Wl,-flat_namespace -Wl,-undefined,dynamic_lookup'}
728 1.1 tron ;;
729 1.1 tron dcosx.1*) SYSTYPE=DCOSX1
730 1.1 tron RANLIB=echo
731 1.1 tron SYSLIBS="-lresolv -lsocket -lnsl -lc -lrpcsvc -L/usr/ucblib -lucb"
732 1.1 tron ;;
733 1.1 tron
734 1.1 tron ".") if [ -d /NextApps ]; then
735 1.1 tron SYSTYPE=`hostinfo | sed -n \
736 1.1 tron 's/^.*NeXT Mach 3.*$/NEXTSTEP3/;/NEXTSTEP3/{p;q;}'`
737 1.1 tron if [ "$SYSTYPE" = "" ]; then
738 1.1 tron SYSTYPE=`hostinfo | sed -n \
739 1.1 tron 's/^.*NeXT Mach 4.*$/OPENSTEP4/;/OPENSTEP4/{p;q;}'`
740 1.1 tron fi
741 1.1 tron : ${CC=cc}
742 1.1 tron RANLIB="sleep 5; ranlib"
743 1.1 tron else
744 1.1 tron error "Unable to determine your system type."
745 1.1 tron fi
746 1.1 tron ;;
747 1.1 tron *) error "Unknown system type: $SYSTEM $RELEASE";;
748 1.1 tron esac
749 1.1 tron
750 1.1 tron #
751 1.1 tron # sigsetjmp()/siglongjmp() can be "better" than setjmp()/longjmp()
752 1.1 tron # if used wisely (that is: almost never, just like signals).
753 1.1 tron # Unfortunately some implementations have been buggy in the past.
754 1.1 tron #
755 1.1 tron case "$CCARGS" in
756 1.1 tron *-DNO_SIGSETJMP*) ;;
757 1.9 tron *) trap 'rm -f makedefs.test makedefs.test.[co]' 1 2 3 15
758 1.1 tron cat >makedefs.test.c <<'EOF'
759 1.1 tron #include <setjmp.h>
760 1.1 tron #include <stdlib.h>
761 1.1 tron #include <stdio.h>
762 1.1 tron
763 1.1 tron static int count = 0;
764 1.1 tron
765 1.1 tron int main(int argc, char **argv)
766 1.1 tron {
767 1.1 tron sigjmp_buf env;
768 1.1 tron int retval;
769 1.1 tron
770 1.1 tron switch (retval = sigsetjmp(env, 1)) {
771 1.1 tron case 0:
772 1.1 tron siglongjmp(env, 12345);
773 1.1 tron case 12345:
774 1.1 tron break;
775 1.1 tron default:
776 1.1 tron fprintf(stderr, "Error: siglongjmp ignores second argument\n");
777 1.1 tron exit(1);
778 1.1 tron }
779 1.1 tron
780 1.1 tron switch (retval = sigsetjmp(env, 1)) {
781 1.1 tron case 0:
782 1.1 tron if (count++ > 0) {
783 1.1 tron fprintf(stderr, "Error: not overriding siglongjmp(env, 0)\n");
784 1.1 tron exit(1);
785 1.1 tron }
786 1.1 tron siglongjmp(env, 0);
787 1.1 tron case 1:
788 1.1 tron break;
789 1.1 tron default:
790 1.1 tron fprintf(stderr, "Error: overriding siglongjmp(env, 0) with %d\n",
791 1.1 tron retval);
792 1.1 tron exit(1);
793 1.1 tron }
794 1.1 tron exit(0);
795 1.1 tron }
796 1.1 tron EOF
797 1.1 tron ${CC-gcc} -o makedefs.test makedefs.test.c || exit 1
798 1.1 tron ./makedefs.test 2>/dev/null ||
799 1.1 tron CCARGS="$CCARGS -DNO_SIGSETJMP"
800 1.1 tron rm -f makedefs.test makedefs.test.[co]
801 1.1 tron esac
802 1.1 tron
803 1.1 tron #
804 1.12 christos # Look for the ICU library and enable unicode email if available.
805 1.12 christos #
806 1.12 christos case "$CCARGS" in
807 1.13 christos *-DNO_EAI*) CCARGS="$CCARGS "'-DDEF_SMTPUTF8_ENABLE=\"no\"';;
808 1.13 christos *) icu_cppflags=`((pkg-config --cflags icu-uc icu-i18n) ||
809 1.13 christos (icu-config --cppflags)) 2>/dev/null` && {
810 1.13 christos icu_ldflags=`((pkg-config --libs icu-uc icu-i18n) ||
811 1.13 christos (icu-config --ldflags)) 2>/dev/null` && {
812 1.12 christos trap 'rm -f makedefs.test makedefs.test.[co]' 1 2 3 15
813 1.12 christos cat >makedefs.test.c <<'EOF'
814 1.12 christos #include <unicode/uidna.h>
815 1.12 christos #include <stdlib.h>
816 1.12 christos
817 1.12 christos int main(int argc, char **argv)
818 1.12 christos {
819 1.12 christos char buf[1024];
820 1.12 christos UErrorCode error = U_ZERO_ERROR;
821 1.12 christos UIDNAInfo info = UIDNA_INFO_INITIALIZER;
822 1.12 christos UIDNA *idna = uidna_openUTS46(UIDNA_DEFAULT, &error);
823 1.12 christos
824 1.12 christos exit(uidna_labelToUnicodeUTF8(idna,
825 1.12 christos "xn--lgbbat1ad8j", /* an arabic TLD */
826 1.12 christos 15,
827 1.12 christos buf,
828 1.12 christos sizeof(buf),
829 1.12 christos &info,
830 1.12 christos &error) != 14);
831 1.12 christos }
832 1.12 christos EOF
833 1.12 christos ${CC-gcc} -o makedefs.test makedefs.test.c $icu_cppflags \
834 1.12 christos $icu_ldflags >/dev/null 2>&1
835 1.12 christos if ./makedefs.test 2>/dev/null ; then
836 1.12 christos CCARGS="$CCARGS $icu_cppflags"
837 1.12 christos SYSLIBS="$SYSLIBS $icu_ldflags"
838 1.12 christos else
839 1.12 christos CCARGS="$CCARGS -DNO_EAI"
840 1.12 christos fi
841 1.12 christos rm -f makedefs.test makedefs.test.[co]
842 1.12 christos }
843 1.13 christos } || CCARGS="$CCARGS -DNO_EAI"' -DDEF_SMTPUTF8_ENABLE=\"no\"'
844 1.12 christos esac
845 1.12 christos
846 1.12 christos #
847 1.1 tron # OpenSSL has no configuration query utility, but we don't try to
848 1.1 tron # guess. We assume includes in /usr/include/openssl and libraries in
849 1.1 tron # /usr/lib, or in their /usr/local equivalents. If the OpenSSL files
850 1.1 tron # are in a non-standard place, their locations need to be specified.
851 1.1 tron #
852 1.1 tron #case "$CCARGS" in
853 1.1 tron # *-DUSE_TLS*) ;;
854 1.1 tron # *-DNO_TLS*) ;;
855 1.1 tron # *) CCARGS="$CCARGS -DUSE_TLS"
856 1.1 tron # AUXLIBS="$AUXLIBS -lssl -lcrypto"
857 1.1 tron # ;;
858 1.1 tron #esac
859 1.1 tron
860 1.1 tron #
861 1.12 christos # We don't know all systems that have /dev/urandom, so we probe.
862 1.12 christos #
863 1.12 christos test -r /dev/urandom && CCARGS="$CCARGS -DHAS_DEV_URANDOM"
864 1.12 christos
865 1.12 christos #
866 1.1 tron # PCRE 3.x has a pcre-config utility so we don't have to guess.
867 1.1 tron #
868 1.1 tron case "$CCARGS" in
869 1.1 tron *-DHAS_PCRE*) ;;
870 1.1 tron *-DNO_PCRE*) ;;
871 1.9 tron *) pcre_cflags=`(pcre-config --cflags) 2>/dev/null` &&
872 1.1 tron pcre_libs=`(pcre-config --libs) 2>/dev/null` && {
873 1.1 tron CCARGS="$CCARGS -DHAS_PCRE $pcre_cflags"
874 1.12 christos AUXLIBS_PCRE="$pcre_libs"
875 1.1 tron }
876 1.1 tron ;;
877 1.1 tron esac
878 1.1 tron
879 1.1 tron # Defaults that can be overruled (make makefiles CC=cc OPT=-O6 DEBUG=)
880 1.1 tron # Disable optimizations by default when compiling for Purify. Disable
881 1.1 tron # optimizations by default with gcc 2.8, until the compiler is known to
882 1.1 tron # be OK. Those who dare can still overrule this (make makefiles OPT=-O).
883 1.1 tron
884 1.1 tron case "$CC" in
885 1.1 tron *purify*) : ${OPT=};;
886 1.1 tron */gcc|gcc) case `$CC -v` in
887 1.1 tron "gcc version 2.8"*) : ${OPT=};;
888 1.1 tron esac;;
889 1.1 tron *CC) error "Don't use CC. That's the C++ compiler";;
890 1.9 tron *) : ${OPT='-O'};;
891 1.1 tron esac
892 1.12 christos
893 1.12 christos # Snapshot only.
894 1.12 christos #CCARGS="$CCARGS -DSNAPSHOT"
895 1.12 christos
896 1.12 christos # Non-production: needs thorough testing, or major changes are still
897 1.12 christos # needed before the code stabilizes.
898 1.12 christos #CCARGS="$CCARGS -DNONPROD"
899 1.12 christos
900 1.12 christos # Workaround: prepend Postfix include files before other include files.
901 1.12 christos CCARGS="-I. -I../../include $CCARGS"
902 1.12 christos
903 1.12 christos # Portability and usability considerations.
904 1.12 christos #
905 1.12 christos # In an ideal world we would be able to provide the option to say
906 1.12 christos # "make makefiles shlib_directory=/some/where/'$mail_version'". This
907 1.12 christos # would allow a running system to be upggraded without worries about
908 1.12 christos # tempororary program-library ABI incompatibilities (the Postfix
909 1.12 christos # library API changes incompatibly from one version to the next).
910 1.12 christos #
911 1.12 christos # Unfortunately, gmake performs macro expansion on values in name=value
912 1.12 christos # command-line arguments. In the specific example above, gmake would
913 1.12 christos # eat up the "$" and "m" before it even invokes makedefs, and it
914 1.12 christos # ould replace "'${mail_version}'" and "'$(mail_version)'" with
915 1.12 christos # nothing.
916 1.1 tron #
917 1.12 christos # Requiring people to specify $$ is not a good option. Instead we
918 1.12 christos # replace the string MAIL_VERSION at the end of parameter values in
919 1.12 christos # "make makefiles name=value...". The replacement depends on usage
920 1.12 christos # context: the expanded release version in actual pathnames, or the
921 1.12 christos # unexpanded ${mail_version} in configuration parameter values (both
922 1.12 christos # main.cf and and built-in defaults).
923 1.12 christos
924 1.12 christos # Helper function to determine DEF_MAIL_VERSION.
925 1.12 christos
926 1.12 christos def_mail_version()
927 1.12 christos {
928 1.12 christos trap 'rm -f makedefs.test makedefs.test.[co]' 1 2 3 15
929 1.12 christos cat > makedefs.test.c <<'EOF'
930 1.12 christos #include <stdlib.h>
931 1.12 christos #include <stdio.h>
932 1.12 christos EOF
933 1.12 christos # Avoid "nested comment" warnings. Top-of-file comments start in
934 1.12 christos # column 1 and have no code after "*/", not even in header files.
935 1.12 christos # If this is insufficient, kill the problem with #ifndef MAKEDEFS.
936 1.12 christos sed '/^\/\*/,/\*\//d' src/global/mail_version.h >>makedefs.test.c
937 1.12 christos cat >>makedefs.test.c <<EOF
938 1.12 christos #include <stdlib.h>
939 1.12 christos #include <stdio.h>
940 1.12 christos #include <string.h>
941 1.12 christos int main(void)
942 1.12 christos {
943 1.12 christos printf("%s\n", DEF_MAIL_VERSION);
944 1.12 christos fflush(stdout);
945 1.12 christos exit(ferror(stdout) ? 1 : 0);
946 1.12 christos }
947 1.12 christos EOF
948 1.12 christos eval ${CC-gcc} ${CCARGS} -o makedefs.test makedefs.test.c || exit 1
949 1.12 christos ./makedefs.test || exit 1
950 1.12 christos rm -f makedefs.test makedefs.test.[co]
951 1.12 christos }
952 1.12 christos
953 1.12 christos # Helper to expand MAIL_VERSION at the end of a command-line parameter value.
954 1.12 christos
955 1.12 christos # Note that MAIL_VERSION) does not anchor the match at the end.
956 1.12 christos
957 1.12 christos process_input_parameter()
958 1.12 christos {
959 1.12 christos echo "#" $parm_name=$parm_val
960 1.12 christos case "$parm_val" in
961 1.12 christos *MAIL_VERSION*)
962 1.12 christos cparm_val=`echo "$parm_val" | \
963 1.12 christos sed 's/MAIL_VERSION$/\\\\$${mail_version}/g'`|| exit 1
964 1.12 christos case "$mail_version" in
965 1.12 christos "") mail_version=`def_mail_version` || exit 1
966 1.12 christos esac
967 1.12 christos parm_val=`echo "$parm_val" | sed 's/MAIL_VERSION$/'"$mail_version/g"` ||
968 1.12 christos exit 1
969 1.12 christos case "$parm_val" in
970 1.12 christos *MAIL_VERSION*)
971 1.12 christos error "MAIL_VERSION not at end of parameter value: $parm_val"
972 1.12 christos esac
973 1.12 christos eval ${parm_name}=\""\$parm_val"\";;
974 1.12 christos *) cparm_val="$parm_val";;
975 1.12 christos esac
976 1.12 christos CCARGS="$CCARGS -D$parm_macro=\\\"$cparm_val\\\""
977 1.12 christos }
978 1.12 christos
979 1.12 christos # Optionally override installation-parameter default settings.
980 1.12 christos
981 1.12 christos command_directory_macro=DEF_COMMAND_DIR
982 1.12 christos config_directory_macro=DEF_CONFIG_DIR
983 1.12 christos daemon_directory_macro=DEF_DAEMON_DIR
984 1.12 christos data_directory_macro=DEF_DATA_DIR
985 1.12 christos mail_spool_directory_macro=DEF_MAIL_SPOOL_DIR
986 1.12 christos mailq_path_macro=DEF_MAILQ_PATH
987 1.12 christos meta_directory_macro=DEF_META_DIR
988 1.12 christos newaliases_path_macro=DEF_NEWALIAS_PATH
989 1.12 christos queue_directory_macro=DEF_QUEUE_DIR
990 1.12 christos sendmail_path_macro=DEF_SENDMAIL_PATH
991 1.12 christos shlib_directory_macro=DEF_SHLIB_DIR
992 1.12 christos openssl_path_macro=DEF_OPENSSL_PATH
993 1.12 christos
994 1.12 christos # shlib_directory is checked here because "no" is not a good answer.
995 1.12 christos # Instead, build with "dynamicmaps=no" and "shared=no" as appropriate.
996 1.12 christos
997 1.12 christos for parm_name in command_directory config_directory daemon_directory \
998 1.12 christos data_directory mail_spool_directory mailq_path meta_directory \
999 1.12 christos newaliases_path queue_directory sendmail_path shlib_directory \
1000 1.12 christos openssl_path
1001 1.12 christos do
1002 1.12 christos eval parm_val=\"\$$parm_name\"
1003 1.12 christos eval parm_macro=\"\$${parm_name}_macro\"
1004 1.12 christos case "$parm_val" in
1005 1.12 christos "") ;;
1006 1.12 christos /*) process_input_parameter;;
1007 1.12 christos *) error "$parm_name must specify an absolute path name";;
1008 1.12 christos esac
1009 1.12 christos done
1010 1.12 christos
1011 1.12 christos html_directory_macro=DEF_HTML_DIR
1012 1.12 christos manpage_directory_macro=DEF_MANPAGE_DIR
1013 1.12 christos readme_directory_macro=DEF_README_DIR
1014 1.12 christos
1015 1.12 christos for parm_name in html_directory manpage_directory readme_directory
1016 1.12 christos do
1017 1.12 christos eval parm_val=\"\$$parm_name\"
1018 1.12 christos eval parm_macro=\"\$${parm_name}_macro\"
1019 1.12 christos case "$parm_val" in
1020 1.12 christos "") ;;
1021 1.12 christos /*|no) process_input_parameter;;
1022 1.12 christos *) error "$parm_name must specify \"no\" or an absolute path name";;
1023 1.12 christos esac
1024 1.12 christos done
1025 1.12 christos
1026 1.12 christos default_database_type_macro=DEF_DB_TYPE
1027 1.12 christos
1028 1.12 christos for parm_name in default_database_type
1029 1.12 christos do
1030 1.12 christos eval parm_val=\"\$$parm_name\"
1031 1.12 christos eval parm_macro=\"\$${parm_name}_macro\"
1032 1.12 christos case "$parm_val" in
1033 1.12 christos "") ;;
1034 1.12 christos *) process_input_parameter;;
1035 1.12 christos esac
1036 1.12 christos done
1037 1.12 christos
1038 1.12 christos echo "# End of summary of user-configurable 'make makefiles' options."
1039 1.12 christos echo "#--------------------------------------------------------------"
1040 1.12 christos
1041 1.12 christos # The following are for non-shared libsasl and libmilter builds.
1042 1.12 christos
1043 1.12 christos _AR=$AR
1044 1.12 christos _RANLIB=$RANLIB
1045 1.12 christos
1046 1.12 christos # Choose between dynamic and static library builds.
1047 1.12 christos
1048 1.12 christos case "$dynamicmaps" in
1049 1.12 christos yes) shared=yes;;
1050 1.12 christos ""|no) ;;
1051 1.12 christos *) error "Specify \"dynamicmaps=yes\" or \"dynamicmaps=no\"";;
1052 1.12 christos esac
1053 1.12 christos
1054 1.12 christos case "$shared" in
1055 1.12 christos yes)
1056 1.12 christos if [ -z "$SHLIB_SUFFIX" ]
1057 1.12 christos then
1058 1.12 christos error "Shared libraries are requested, but not supported on this platform"
1059 1.12 christos fi
1060 1.12 christos AR=:
1061 1.12 christos RANLIB=:
1062 1.12 christos CCARGS="$CCARGS -DUSE_DYNAMIC_LIBS"
1063 1.12 christos case "$dynamicmaps" in
1064 1.12 christos yes) NON_PLUGIN_MAP_OBJ=
1065 1.12 christos PLUGIN_MAP_OBJ='$(MAP_OBJ)'
1066 1.12 christos PLUGIN_MAP_OBJ_UPDATE=plugin_map_obj_update
1067 1.12 christos PLUGIN_MAP_SO_MAKE=plugin_map_so_make
1068 1.12 christos PLUGIN_MAP_SO_UPDATE=plugin_map_so_update
1069 1.12 christos CCARGS="$CCARGS -DUSE_DYNAMIC_MAPS"
1070 1.12 christos ;;
1071 1.12 christos *) NON_PLUGIN_MAP_OBJ='$(MAP_OBJ)'
1072 1.12 christos PLUGIN_MAP_OBJ=
1073 1.12 christos PLUGIN_MAP_OBJ_UPDATE=
1074 1.12 christos PLUGIN_MAP_SO_MAKE=
1075 1.12 christos PLUGIN_MAP_SO_UPDATE=
1076 1.12 christos PLUGIN_LD=
1077 1.12 christos CCARGS="$CCARGS -UUSE_DYNAMIC_MAPS"
1078 1.12 christos ;;
1079 1.12 christos esac
1080 1.12 christos
1081 1.12 christos # Determine the dynamically-linked library and plugin installation
1082 1.12 christos # directory.
1083 1.12 christos
1084 1.12 christos parm_name=shlib_directory
1085 1.12 christos eval parm_val=\"\$$parm_name\"
1086 1.12 christos eval parm_macro=\"\$${parm_name}_macro\"
1087 1.12 christos case "$parm_val" in
1088 1.12 christos /*|no) # CCARGS was already updated above.
1089 1.12 christos ;;
1090 1.12 christos "") trap 'rm -f makedefs.test makedefs.test.[co]' 1 2 3 15
1091 1.12 christos sed -n '
1092 1.12 christos /_SHLIB_DIR/,/^$/p
1093 1.12 christos ' src/global/mail_params.h >makedefs.test.c
1094 1.12 christos cat >>makedefs.test.c <<EOF
1095 1.12 christos #include <stdlib.h>
1096 1.12 christos #include <stdio.h>
1097 1.12 christos int main(void)
1098 1.12 christos {
1099 1.12 christos printf("%s\n", $parm_macro);
1100 1.12 christos fflush(stdout);
1101 1.12 christos exit(ferror(stdout) ? 1 : 0);
1102 1.12 christos }
1103 1.12 christos EOF
1104 1.12 christos eval ${CC-gcc} ${CCARGS} -o makedefs.test makedefs.test.c || exit 1
1105 1.12 christos parm_val=`./makedefs.test` || exit 1
1106 1.12 christos rm -f makedefs.test makedefs.test.[co]
1107 1.12 christos eval ${parm_name}=\""\$parm_val"\"
1108 1.12 christos #CCARGS="$CCARGS -D$parm_macro=\\\"$parm_val\\\""
1109 1.12 christos ;;
1110 1.12 christos *) # this parameter was already checked above.
1111 1.12 christos error "Can't happen in $0 - $parm_val is not an absolute path"
1112 1.12 christos ;;
1113 1.12 christos esac
1114 1.12 christos
1115 1.12 christos LIB_PREFIX=postfix-
1116 1.12 christos LIB_SUFFIX=${SHLIB_SUFFIX}
1117 1.12 christos ;;
1118 1.12 christos
1119 1.12 christos no|"")
1120 1.12 christos shlib_directory=no
1121 1.12 christos CCARGS="$CCARGS -UUSE_DYNAMIC_LIBS -DDEF_SHLIB_DIR=\\\"no\\\""
1122 1.12 christos CCARGS="$CCARGS -UUSE_DYNAMIC_MAPS"
1123 1.12 christos SHLIB_CFLAGS=
1124 1.12 christos SHLIB_SUFFIX=
1125 1.12 christos SHLIB_LD=:
1126 1.12 christos SHLIB_SYSLIBS=
1127 1.12 christos SHLIB_RPATH=
1128 1.12 christos SHLIB_ENV=
1129 1.12 christos LIB_PREFIX=
1130 1.12 christos LIB_SUFFIX=.a
1131 1.12 christos NON_PLUGIN_MAP_OBJ='$(MAP_OBJ)'
1132 1.12 christos PLUGIN_MAP_OBJ=
1133 1.12 christos PLUGIN_MAP_OBJ_UPDATE=
1134 1.12 christos PLUGIN_MAP_SO_MAKE=
1135 1.12 christos PLUGIN_MAP_SO_UPDATE=
1136 1.12 christos PLUGIN_LD=
1137 1.12 christos ;;
1138 1.12 christos
1139 1.12 christos *) error "Specify \"shared=yes\" or \"shared=no\""
1140 1.12 christos ;;
1141 1.12 christos esac
1142 1.12 christos
1143 1.1 tron # "gcc -W" 3.4.2 no longer reports functions that fail to return a
1144 1.1 tron # result. Use "gcc -Wall -Wno-comment" instead. We'll figure out
1145 1.1 tron # later if the other -Wmumble options are really redundant. Having
1146 1.1 tron # een burned once by a compiler that lies about what warnings it
1147 1.1 tron # produces, not taking that chance again.
1148 1.1 tron
1149 1.11 tron : ${CC=gcc} ${OPT='-O'} ${DEBUG='-g'} ${AWK=awk} \
1150 1.1 tron ${WARN='-Wall -Wno-comment -Wformat -Wimplicit -Wmissing-prototypes \
1151 1.1 tron -Wparentheses -Wstrict-prototypes -Wswitch -Wuninitialized \
1152 1.14 christos -Wunused -Wno-missing-braces -fcommon'}
1153 1.1 tron
1154 1.12 christos # Extract map type names from -DHAS_XXX compiler options. We avoid
1155 1.12 christos # problems with tr(1) range syntax by using enumerations instead,
1156 1.12 christos # and we don't try to figure out which awk versions have tolower().
1157 1.12 christos # The following was validated in 2014 on FreeBSD/Linux and Solaris 9.
1158 1.12 christos
1159 1.12 christos DEFINED_MAP_TYPES=`
1160 1.12 christos echo $CCARGS | tr -cd '\- _ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789' |
1161 1.12 christos tr ABCDEFGHIJKLMNOPQRSTUVWXYZ abcdefghijklmnopqrstuvwxyz | ${AWK} '
1162 1.12 christos { for (n = 1; n <= NF; n++)
1163 1.12 christos if ($n ~ /^-dhas_/)
1164 1.12 christos if (seen[name = substr($n, 7)]++ == 0)
1165 1.12 christos printf(" %s", name) }
1166 1.12 christos '`
1167 1.12 christos
1168 1.12 christos # Propagate AUXLIBS_FOO or merge them into global AUXLIBS (i.e. SYSLIBS).
1169 1.12 christos
1170 1.12 christos PLUGGABLE_MAPS="CDB LDAP LMDB MYSQL PCRE PGSQL SDBM SQLITE"
1171 1.12 christos
1172 1.12 christos case "$dynamicmaps" in
1173 1.12 christos yes) for name in $PLUGGABLE_MAPS
1174 1.12 christos do
1175 1.12 christos eval test -n "\"\$AUXLIBS_$name\"" &&
1176 1.12 christos eval PLUGIN_AUXLIBS="\"\$PLUGIN_AUXLIBS
1177 1.12 christos AUXLIBS_$name = \$AUXLIBS_$name\""
1178 1.12 christos done;;
1179 1.12 christos *) for name in $PLUGGABLE_MAPS
1180 1.12 christos do
1181 1.12 christos eval AUXLIBS="\"\$AUXLIBS \$AUXLIBS_$name\""
1182 1.12 christos done;;
1183 1.12 christos esac
1184 1.12 christos
1185 1.12 christos # Remove static libraries from SYSLIBS when building shared objects,
1186 1.12 christos # Can't use the shell "case" patterns to detect names ending in *.a.
1187 1.1 tron
1188 1.12 christos case "$shared" in
1189 1.12 christos yes) SHLIB_SYSLIBS=`${AWK} '
1190 1.12 christos BEGIN { wc = split("'"$AUXLIBS $SYSLIBS"'", words)
1191 1.12 christos for (n = 1; n <= wc; n++)
1192 1.12 christos if (words[n] !~ /\.a$/)
1193 1.12 christos printf(" %s", words[n])
1194 1.12 christos }
1195 1.12 christos '`
1196 1.12 christos esac
1197 1.12 christos
1198 1.12 christos # Choose between PIE and non-PIE builds.
1199 1.1 tron
1200 1.12 christos case "$pie" in
1201 1.12 christos yes) case "$shared" in
1202 1.12 christos yes) CCARGS_PIE="-fPIC";;
1203 1.12 christos *) CCARGS_PIE="-fPIE";;
1204 1.12 christos esac
1205 1.12 christos case " $CCARGS " in
1206 1.12 christos *" $CCARGS_PIE "*) CCARGS_PIE=;;
1207 1.12 christos esac
1208 1.12 christos SYSLIBS_PIE="-pie";;
1209 1.12 christos ""|no) ;;
1210 1.12 christos *) error "Specify \"pie=yes\" or \"pie=no\"";;
1211 1.12 christos esac
1212 1.1 tron
1213 1.13 christos # Don't permit random overrides.
1214 1.13 christos allowed_user_install_opts="-keep-build-mtime"
1215 1.13 christos for opt in $POSTFIX_INSTALL_OPTS
1216 1.13 christos do
1217 1.13 christos (for allowed in -keep-build-mtime
1218 1.13 christos do
1219 1.13 christos test "$opt" = "$allowed" && exit 0
1220 1.13 christos done; exit 1) || error "invalid option '$opt' in POSTFIX_INSTALL_OPTS"
1221 1.13 christos done
1222 1.13 christos
1223 1.12 christos # Finally...
1224 1.9 tron
1225 1.12 christos sed 's/ */ /g' <<EOF
1226 1.12 christos # System-dependent settings and compiler/linker overrides.
1227 1.1 tron SYSTYPE = $SYSTYPE
1228 1.12 christos _AR = $_AR
1229 1.1 tron ARFL = $ARFL
1230 1.12 christos _RANLIB = $_RANLIB
1231 1.12 christos SYSLIBS = $SYSLIBS_PIE $AUXLIBS $SYSLIBS $PLUGIN_AUXLIBS
1232 1.12 christos CC = $CC $CCARGS_PIE $CCARGS \$(WARN)
1233 1.1 tron OPT = $OPT
1234 1.1 tron DEBUG = $DEBUG
1235 1.1 tron AWK = $AWK
1236 1.1 tron STRCASE = $STRCASE
1237 1.12 christos EXPORT = CCARGS='$CCARGS' OPT='$OPT' DEBUG='$DEBUG'
1238 1.1 tron WARN = $WARN
1239 1.12 christos DEFINED_MAP_TYPES = $DEFINED_MAP_TYPES
1240 1.12 christos MAKE_FIX = $MAKE_FIX
1241 1.12 christos # Switch between Postfix static and dynamically-linked libraries.
1242 1.12 christos AR = $AR
1243 1.12 christos RANLIB = $RANLIB
1244 1.12 christos LIB_PREFIX = $LIB_PREFIX
1245 1.12 christos LIB_SUFFIX = $LIB_SUFFIX
1246 1.12 christos SHLIB_CFLAGS = $SHLIB_CFLAGS
1247 1.12 christos SHLIB_DIR = $shlib_directory
1248 1.12 christos SHLIB_ENV = $SHLIB_ENV
1249 1.12 christos SHLIB_LD = $SHLIB_LD
1250 1.12 christos SHLIB_SYSLIBS = $SHLIB_SYSLIBS
1251 1.12 christos SHLIB_RPATH = $SHLIB_RPATH
1252 1.12 christos # Switch between dynamicmaps.cf plugins and hard-linked databases.
1253 1.12 christos NON_PLUGIN_MAP_OBJ = $NON_PLUGIN_MAP_OBJ
1254 1.12 christos PLUGIN_MAP_OBJ = $PLUGIN_MAP_OBJ
1255 1.12 christos PLUGIN_MAP_OBJ_UPDATE = $PLUGIN_MAP_OBJ_UPDATE
1256 1.12 christos PLUGIN_MAP_SO_MAKE = $PLUGIN_MAP_SO_MAKE
1257 1.12 christos PLUGIN_MAP_SO_UPDATE = $PLUGIN_MAP_SO_UPDATE
1258 1.12 christos PLUGIN_LD = $PLUGIN_LD
1259 1.13 christos POSTFIX_INSTALL_OPTS = $POSTFIX_INSTALL_OPTS
1260 1.12 christos # Application-specific rules.
1261 1.1 tron EOF
1262